gc: retain recently unreferenced objects for 1 day
[girocco.git] / shlib.sh
blob6e2dd1f5985caaa65a2045a200a7c44bc681ded7
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 # SHA-1 patterns
7 octet='[0-9a-f][0-9a-f]'
8 octet4="$octet$octet$octet$octet"
9 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20="$octet4$octet4$octet4$octet4$octet4"
11 nullsha="0000000000000000000000000000000000000000"
12 # tab
13 tab="$(printf '\t')"
15 # set a sane umask that never excludes any user or group permissions
16 umask $(printf '0%03o' $(( $(umask) & ~0770 )) )
18 vcmp() {
19 # Compare $1 to $2 each of which must match \d+(\.\d+)*
20 # An empty string ('') for $1 or $2 is treated like 0
21 # Outputs:
22 # -1 if $1 < $2
23 # 0 if $1 = $2
24 # 1 if $1 > $2
25 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
26 while
27 _a="${1%%.*}"
28 _b="${2%%.*}"
29 [ -n "$_a" -o -n "$_b" ]
31 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
32 echo -1
33 return
34 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
35 echo 1
36 return
38 _a2="${1#$_a}"
39 _b2="${2#$_b}"
40 set -- "${_a2#.}" "${_b2#.}"
41 done
42 echo 0
45 get_girocco_config_pm_var_list() {
46 # Export all the variables from Girocco::Config to suitable var= lines
47 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
48 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
49 __girocco_conf="$GIROCCO_CONF"
50 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
51 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
52 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
53 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
54 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
55 $val =~ s/([\\"\$\`])/\\$1/gos;
56 $val =~ s/(?:\r\n|\r|\n)$//os;
57 print "cfg_$_=\"$val\"";
58 print "defined_cfg_$_=",
59 (defined(${$Girocco::Config::{$_}})?"1":"");
63 get_girocco_config_var_list() (
64 # Same as get_girocco_config_pm_var_list except that
65 # the following variables (all starting with var_) are added:
66 # var_group cfg_owning_group if defined otherwise `id -gn`
67 # var_git_ver The version number part from `git version`
68 # var_git_exec_path The result of $cfg_git_bin --exec-dir
69 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
70 # var_have_git_173 Set to 1 if git version >= 1.7.3 otherwise ''
71 # var_window_memory Value to use for repack --window-memory=
72 # var_log_window_size Value to use for git-svn --log-window-size=
73 # var_utf8_locale Value to use for a UTF-8 locale if available
74 # var_xargs_r A "-r" if xargs needs it to behave correctly
75 # var_du_exclude Option to exclude PATTERN from du if available
76 # var_du_follow Option to follow command line sym links if available
77 _cfg_vars="$(get_girocco_config_pm_var_list)"
78 eval "$_cfg_vars"
79 printf '%s\n' "$_cfg_vars"
80 printf 'var_group=%s\n' "${cfg_owning_group:-$(id -gn)}"
81 _gver="$("$cfg_git_bin" version 2>/dev/null | \
82 sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
83 printf 'var_git_ver=%s\n' "$_gver"
84 printf 'var_git_exec_path="%s"\n' "$("$cfg_git_bin" --exec-path 2>/dev/null)"
85 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
86 printf 'var_have_git_173=%s\n' "$([ $(vcmp "$_gver" 1.7.3) -ge 0 ] && echo 1)"
87 __girocco_conf="$GIROCCO_CONF"
88 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
89 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
90 printf "var_window_memory=%s\n" \
91 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
92 -MGirocco::Util -e 'print calc_windowmemory')"
93 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
94 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
95 _guess_locale="$(locale -a | grep -viE '^(posix|c)(\..*)?$' | \
96 grep -iE '\.utf-?8$' | sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
97 sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
98 head -n 1 | cut -d ' ' -f 2)"
99 [ -z "$_guess_locale" ] || printf 'var_utf8_locale=%s.UTF-8\n' "$_guess_locale"
100 # On some broken platforms running xargs without -r and empty input runs the command
101 printf 'var_xargs_r=%s\n' "$(: | command xargs echo -r)"
102 # The disk usage report produces better numbers if du has an exclude option
103 _x0="$(basename "$0")"
104 _x0="${_x0%?}?*"
105 for _duopt in --exclude -I; do
106 if _test="$(du $_duopt 's?lib.s*' $_duopt "$_x0" "$0" 2>/dev/null)" && [ -z "$_test" ]; then
107 printf 'var_du_exclude=%s\n' "$_duopt"
108 break
110 done
111 if _test="$(du -H "$0" 2>/dev/null)" && [ -n "$_test" ]; then
112 printf 'var_du_follow=%s\n' "-H"
113 break
117 # If basedir has been replaced, and shlib_vars.sh exists, get the config
118 # definitions from it rather than running Perl.
119 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
120 # Import all the variables from Girocco::Config to the local environment,
121 eval "$(get_girocco_config_var_list)"
122 else
123 # Import the variables from shlib_vars.sh which avoids needlessly
124 # running another copy of Perl
125 . "@basedir@/shlib_vars.sh"
128 # Make sure we have a reproducible environment by using a controlled HOME dir
129 XDG_CONFIG_HOME="$cfg_chroot/var/empty"
130 HOME="$cfg_chroot/etc/girocco"
131 GIT_CONFIG_NOSYSTEM=1
132 GIT_ATTR_NOSYSTEM=1
133 GIT_NO_REPLACE_OBJECTS=1
134 GIT_TERMINAL_PROMPT=0
135 GIT_ASKPASS="$cfg_basedir/bin/git-askpass-password"
136 export XDG_CONFIG_HOME
137 export HOME
138 export GIT_CONFIG_NOSYSTEM
139 export GIT_ATTR_NOSYSTEM
140 export GIT_NO_REPLACE_OBJECTS
141 export GIT_TERMINAL_PROMPT
142 export GIT_ASKPASS
143 unset GIT_USER_AGENT
144 unset GIT_HTTP_USER_AGENT
145 if [ -n "$defined_cfg_git_client_ua" ]; then
146 GIT_USER_AGENT="$cfg_git_client_ua"
147 export GIT_USER_AGENT
148 GIT_HTTP_USER_AGENT="$cfg_git_client_ua"
149 export GIT_HTTP_USER_AGENT
152 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
153 # and nc_openbsd to the desired executables because when using
154 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
155 # different and unexpected ways:
156 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
157 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
158 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
159 # None of these are good. We want a temporary "export ENV_VAR=xxx"
160 # setting only while running func which none of the /bin/sh's do.
162 # Instead we'd like to use an alias that provides the desired behavior without
163 # any of the bad (a), (b) or (c) effects.
165 # However, unfortunately, some of the crazy /bin/sh implementations do not
166 # recognize alias expansions when preceded by variable assignments!
168 # So we are left with git() {} and nc_openbsd() {} functions and in the
169 # case of git() {} we can compensate for (b) and (c) failing to export
170 # but not (a) and (b) persisting the values so the caller will simply
171 # have to beware and explicitly unset any variables that should not persist
172 # beyond the function call itself.
174 git() (
175 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
176 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
177 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
178 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
179 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
180 exec "$cfg_git_bin" "$@"
183 nc_openbsd() { "$cfg_nc_openbsd_bin" "$@"; }
185 # Some platforms' broken xargs runs the command always at least once even if
186 # there's no input unless given a special option. Automatically supply the
187 # option on those platforms by providing an xargs function.
188 xargs() { command xargs $var_xargs_r "$@"; }
190 _addrlist() {
191 _list=
192 for _addr in "$@"; do
193 [ -z "$_list" ] || _list="$_list, "
194 _list="$_list$_addr"
195 done
196 echo "$_list"
199 _sendmail() {
200 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
201 if [ -n "$cfg_sender" ]; then
202 "$_mailer" -i -f "$cfg_sender" "$@"
203 else
204 "$_mailer" -i "$@"
208 mail() {
209 _subject=
210 if [ "$1" = "-s" ]; then
211 shift
212 _subject="$1"
213 shift
216 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
217 echo "To: $(_addrlist "$@")"
218 [ -z "$_subject" ] || echo "Subject: $_subject"
219 echo "MIME-Version: 1.0"
220 echo "Content-Type: text/plain; charset=utf-8"
221 echo "Content-Transfer-Encoding: 8bit"
222 echo "Auto-Submitted: auto-generated"
223 echo ""
225 } | _sendmail "$@"
228 # bang CMD... will execute the command with well-defined failure mode;
229 # set bang_action to string of the failed action ('clone', 'update', ...);
230 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
231 # not spam the owner; re-define the bang_trap() function to do custom
232 # cleanup before bailing out
233 bang() {
234 if [ -n "$show_progress" ]; then
235 exec 3>&1
236 errcode=
237 read -r errcode <<-EOT || :
239 exec 4>&3 3>&1 1>&4 4>&-
240 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
243 exec 3>&-
244 if [ -z "$errcode" ]; then
245 # All right. Cool.
246 return;
248 else
249 if "$@" >>"$bang_log" 2>&1; then
250 # All right. Cool.
251 return;
252 else
253 errcode="$?"
256 if ! [ -e .banged ] || [ -e .bangagain ]; then
257 rm -f .bangagain
258 bangmailok=true
259 ! [ -f HEAD -a -f config -a -d objects ] ||
260 bangmailok="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
261 bangaddrs=''
262 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs="$mail"
263 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
264 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
265 [ -z "$bangaddrs" ] ||
267 echo "$* failed with error code $errcode"
268 echo ""
269 [ ! -n "$bang_once" ] || echo "you will not receive any more notifications until recovery"
270 echo "this status message may be disabled on the project admin page"
271 echo ""
272 echo "Log follows:"
273 echo ""
274 cat "$bang_log"
275 } | mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
277 touch .banged
278 cat "$bang_log" > .banglog
279 bang_trap
280 exit 1
283 # bang_eval CMD... will evaluate the command with well-defined failure mode;
284 # Identical to bang CMD... except the command is eval'd instead of executed.
285 bang_eval() {
286 bang eval "$*"
289 # Default bang settings:
290 bang_setup() {
291 bang_action="lame_programmer"
292 bang_once=
293 bang_trap() { :; }
294 bang_log="$(mktemp -t repomgr-XXXXXX)"
295 trap 'rm -f "$bang_log"' EXIT
296 trap 'exit 130' INT
297 trap 'exit 143' TERM
300 # Remove banged status
301 bang_reset() {
302 rm -f .banged .bangagain .banglog
305 # Check to see if banged status
306 is_banged() {
307 [ -e .banged ]
311 # Progress report - if show_progress is set, shows the given message.
312 progress() {
313 [ ! -n "$show_progress" ] || echo "$@"
317 # Project config accessors; must be run in project directory
318 config_get() {
319 git config "gitweb.$1"
322 config_set() {
323 git config "gitweb.$1" "$2" && chgrp $var_group config && chmod g+w config
326 config_set_raw() {
327 git config "$1" "$2" && chgrp $var_group config && chmod g+w config
330 config_get_date_seconds() {
331 _dt="$(config_get "$1" || :)"
332 [ -n "$_dt" ] || return 1
333 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date('$_dt')")"
334 [ -n "$_ds" ] || return 1
335 echo "$_ds"
338 # Tool for checking whether given number of seconds has not passed yet
339 check_interval() {
340 os="$(config_get_date_seconds "$1")" || return 1
341 ns="$(date +%s)"
342 [ $ns -lt $(($os+$2)) ]
345 # Check if we are running with effective root permissions
346 is_root() {
347 [ "$(id -u 2>/dev/null)" = "0" ]
350 # Check to see if the single argument is a Git directory
351 is_git_dir() {
352 # Just like Git's test except we ignore GIT_OBJECT_DIRECTORY
353 # And we are slightly more picky (must be refs/.+ not refs/.*)
354 [ -d "$1/objects" -a -x "$1/objects" ] || return 1
355 [ -d "$1/refs" -a -x "$1/refs" ] || return 1
356 if [ -L "$1/HEAD" ]; then
357 _hr="$(readlink "$1/HEAD")"
358 case "$_hr" in "refs/"?*) :;; *) return 1;; esac
360 [ -f "$1/HEAD" -a -r "$1/HEAD" ] || return 1
361 read -r _hr <"$1/HEAD" || return 1
362 case "$_hr" in
363 $octet20)
364 return 0;;
365 ref:*)
366 _hr="${_hr##ref:*[ $tab]}"
367 case "$_hr" in "refs/"?*) return 0;; esac
368 esac
369 return 1
372 # List all Git repositories, with given prefix if specified, one-per-line
373 # All project names starting with _ are always excluded from the result
374 get_repo_list() {
375 if [ -n "$1" ]; then
376 cut -d : -f 1,3 "$cfg_chroot"/etc/group | grep "^$1"
377 else
378 cut -d : -f 1,3 "$cfg_chroot"/etc/group
379 fi | while IFS=: read name id; do
380 [ $id -lt 65536 ] || case "$name" in _*) :;; ?*) echo "$name"; esac
381 done
384 # returns empty string for non-mirrors, otherwise one of:
385 # m => normal Git mirror
386 # s => mirror from svn source
387 # d => mirror from darcs source
388 # b => mirror from bzr source
389 # h => mirror from hg source
390 # the optional passed in git dir defaults to "."
391 # will fail if the directory does not have .nofetch and gitweb.baseurl
392 # comes back empty
393 get_mirror_type() {
394 _gitdir="${1:-.}"
395 # always return empty for non-mirrors
396 [ ! -e "$_gitdir/.nofetch" ] || return 0
397 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
398 _url="${_url##* }"
399 case "$_url" in
401 return 1
403 svn://* | svn+http://* | svn+https://*)
404 echo 's'
406 darcs://*)
407 echo 'd'
409 bzr://*)
410 echo 'b'
412 hg+http://* | hg+https://*)
413 echo 'h'
416 echo 'm'
418 esac
419 return 0
422 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
423 is_gfi_mirror() {
424 case "$(get_mirror_type "$1" 2>/dev/null || :)" in
425 d|b|h)
426 # darcs, bzr and hg mirrors use git fast-import
427 return 0
430 # Don't think git-svn currently uses git fast-import
431 # And Git mirrors certainly do not
432 return 1
434 esac
435 # assume it does not use git fast-import
436 return 1
439 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
440 is_svn_mirror() {
441 [ "$(get_mirror_type "$1" 2>/dev/null || :)" = "s" ]
444 # A well-known UTF-8 locale is required for some of the fast-import providers
445 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
446 # but that is not reliably UTF-8 but rather usually US-ASCII.
447 # We parse the output of `locale -a` and select a suitable UTF-8 locale at
448 # install time and store that in $var_utf8_locale if one is found.
449 # If we cannot find one in the `locale -a` output then we just use a well-known
450 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
451 # it. We only set this temporarily when running the fast-import providers.
452 set_utf8_locale() {
453 LC_ALL="${var_utf8_locale:-en_US.UTF-8}"
454 export LC_ALL
457 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
458 git_hg_fetch() (
459 set_utf8_locale
460 _python="${PYTHON:-python}"
461 _err1=
462 _err2=
463 exec 3>&1
464 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
466 exec 4>&3 3>&1 1>&4 4>&-
468 _e1=0
469 [ -f hg2git-marks ] || touch hg2git-marks
470 _af="$(git config hg.authorsfile || :)"
471 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
472 --repo "$(pwd)/repo.hg" \
473 --marks "$(pwd)/hg2git-marks" \
474 --mapping "$(pwd)/hg2git-mapping" \
475 --heads "$(pwd)/hg2git-heads" \
476 --status "$(pwd)/hg2git-state" \
477 -U unknown --force --flatten --hg-hash'
478 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
479 eval "$_cmd" 3>&- || _e1=$?
480 echo $_e1 >&3
481 } | \
483 _e2=0
484 rm -f hg2git-marks.new
485 git fast-import \
486 --export-marks="$(pwd)/hg2git-marks.new" \
487 --export-pack-edges="$(pwd)/gfi-packs" \
488 --force 3>&- || _e2=$?
489 echo $_e2 >&3
493 exec 3>&-
494 [ "$_err1" = 0 -a "$_err2" = 0 ] || return 1
495 if [ -f hg2git-marks ]; then
496 rm -f hg2git-marks.old
497 mv hg2git-marks hg2git-marks.old
498 else
499 touch hg2git-marks.old
501 cat hg2git-marks.old hg2git-marks.new | \
502 LC_ALL=C sort -t : -k2,2n -u | \
503 sed -ne "/^:[1-9][0-9]* $octet20\$/p" > hg2git-marks
504 rm hg2git-marks.old hg2git-marks.new
505 rm -f hg2git-heads
506 git branch --no-color | \
507 while IFS= read -r _head; do
508 echo ":${_head#??} $(git rev-parse "refs/heads/${_head#??}")"
509 done > hg2git-heads